<template>
  <div class="layout-wrapper p-input-filled">
    <header>
      <appHeader/>
    </header>
    <main>
      <router-view/>
    </main>
    <footer>
      <appFooter/>
    </footer>
  </div>
</template>

<script>
import { defineAsyncComponent } from 'vue';
import { useReCaptcha } from 'vue-recaptcha-v3';

export default {
  name: 'App',
  components: {
    appHeader: defineAsyncComponent(() => import(/* webpackChunkName: "appHeader" */ './components/layout/appHeader')),
    appFooter: defineAsyncComponent(() => import(/* webpackChunkName: "appFooter" */ './components/layout/appFooter')),
  },
  provide() {
    return {
      recaptcha: this.recaptcha,
    };
  },
  setup() {
    const {
      executeRecaptcha,
      recaptchaLoaded,
    } = useReCaptcha();

    const recaptcha = async (actionName = 'test') => {
      await recaptchaLoaded();

      return executeRecaptcha(actionName);
    };

    return {
      recaptcha,
    };
  },
};
</script>
